# coding: utf-8

"""
    Agent Management API

    API for managing agents, their templates, and call logs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from smallestai.atoms.models.agent_dto import AgentDTO
from typing import Optional, Set
from typing_extensions import Self

class GetAgents200ResponseData(BaseModel):
    """
    GetAgents200ResponseData
    """ # noqa: E501
    agents: Optional[List[AgentDTO]] = None
    total_count: Optional[StrictInt] = Field(default=None, description="Total number of agents", alias="totalCount")
    has_more: Optional[StrictBool] = Field(default=None, description="Whether there are more agents to fetch", alias="hasMore")
    is_search_results: Optional[StrictBool] = Field(default=None, description="Whether the results are from a search query", alias="isSearchResults")
    __properties: ClassVar[List[str]] = ["agents", "totalCount", "hasMore", "isSearchResults"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetAgents200ResponseData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in agents (list)
        _items = []
        if self.agents:
            for _item_agents in self.agents:
                if _item_agents:
                    _items.append(_item_agents.to_dict())
            _dict['agents'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetAgents200ResponseData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "agents": [AgentDTO.from_dict(_item) for _item in obj["agents"]] if obj.get("agents") is not None else None,
            "totalCount": obj.get("totalCount"),
            "hasMore": obj.get("hasMore"),
            "isSearchResults": obj.get("isSearchResults")
        })
        return _obj


