# coding: utf-8

"""
    Agent Management API

    API for managing agents, their templates, and call logs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GetCurrentUser200ResponseData(BaseModel):
    """
    GetCurrentUser200ResponseData
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="The ID of the user", alias="_id")
    first_name: Optional[StrictStr] = Field(default=None, description="The first name of the user", alias="firstName")
    last_name: Optional[StrictStr] = Field(default=None, description="The last name of the user", alias="lastName")
    user_email: Optional[StrictStr] = Field(default=None, description="The email of the user", alias="userEmail")
    auth_provider: Optional[StrictStr] = Field(default=None, description="The authentication provider of the user", alias="authProvider")
    is_email_verified: Optional[StrictBool] = Field(default=None, description="Whether the user's email is verified", alias="isEmailVerified")
    organization_id: Optional[StrictStr] = Field(default=None, alias="organizationId")
    __properties: ClassVar[List[str]] = ["_id", "firstName", "lastName", "userEmail", "authProvider", "isEmailVerified", "organizationId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetCurrentUser200ResponseData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetCurrentUser200ResponseData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_id": obj.get("_id"),
            "firstName": obj.get("firstName"),
            "lastName": obj.get("lastName"),
            "userEmail": obj.get("userEmail"),
            "authProvider": obj.get("authProvider"),
            "isEmailVerified": obj.get("isEmailVerified"),
            "organizationId": obj.get("organizationId")
        })
        return _obj


